Bug 1400476

Summary: Nightly compose, ppc64le ISO fails to boot with error "( 700 ) Program Exception [ 0 ]"
Product: [Fedora] Fedora Reporter: Sinny Kumari <skumari>
Component: grub2Assignee: Peter Jones <pjones>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: rawhideCC: dan, hannsj_uhl, lkundrak, pjones
Target Milestone: ---   
Target Release: ---   
Hardware: ppc64le   
OS: Unspecified   
Whiteboard:
Fixed In Version: grub2-2.02-0.38.fc25 Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2016-12-09 12:46:41 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On:    
Bug Blocks: 1071880    
Attachments:
Description Flags
ppc64le iso boot failure message screenshot none

Description Sinny Kumari 2016-12-01 10:32:37 UTC
Created attachment 1226733 [details]
ppc64le iso boot failure message screenshot

Description of problem:
When trying to boot latest ppc64le iso from Rawhide nightly composes, it fails to boot. Error message appears on screen is:
  "( 700 ) Program Exception [ 0 ]".

Screenshot of message printed during boot failure is also available in this bugzilla attachment.

Version-Release number of selected component (if applicable): grub2-2.02-0.34.fc26.ppc64le.rpm

Steps to Reproduce:
1. Get a ppc64le ISO from Rawhide nightly composes e.g. https://kojipkgs.fedoraproject.org/compose/rawhide/Fedora-Rawhide-20161128.n.0/compose/Server/ppc64le/iso/
2. Boot from downloaded ISO and error will appear during boot process

Actual results:
Fails to boot

Expected results:
Should boot successfully

Additional info: 
1. To confirm the problem, I updated grub2 package on my F25, ppc64le box from grub2-2.02-0.34.fc24.ppc64le.rpm to grub2-2.02-0.34.fc26.ppc64le.rpm. Also updated grub2-tools-2.02-0.34.fc24.ppc64le.rpm to grub2-tools-2.02-0.34.fc26.ppc64le.rpm. Then ran command "grub2-install" and rebooted system. Got same Program Exception error during boot.
2. It might be related to BZ#1334672 and possibly fixes made in F24 dist-git branch has not been merged to master branch.

Comment 1 Dan Horák 2016-12-01 17:05:47 UTC
Peter suggested to use a regex in the sed command swapping the default -mcpu to power6

...
@@ -273,7 +273,7 @@ cd grub-%{tarversion}
                -e 's/-fexceptions//g'                          \
                -e 's/-m64//g'                                  \
                -e 's/-fasynchronous-unwind-tables//g'          \
-               -e 's/-mcpu=power7/-mcpu=power6/g'              \
+               -e 's/-mcpu=power[[:alnum:]]\+/-mcpu=power6/g'  \
                -e 's/^/ -fno-strict-aliasing /' )"             \
        TARGET_LDFLAGS=-static                                  \
         --with-platform=%{platform}                            \
...

a scratch build with this fix applied is at
http://koji.fedoraproject.org/koji/taskinfo?taskID=16697884
Please test before we will commit the fix and do a proper build.

Comment 2 Sinny Kumari 2016-12-04 16:20:52 UTC
(In reply to Dan Horák from comment #1)
> Peter suggested to use a regex in the sed command swapping the default -mcpu
> to power6
> 
> ...
> @@ -273,7 +273,7 @@ cd grub-%{tarversion}
>                 -e 's/-fexceptions//g'                          \
>                 -e 's/-m64//g'                                  \
>                 -e 's/-fasynchronous-unwind-tables//g'          \
> -               -e 's/-mcpu=power7/-mcpu=power6/g'              \
> +               -e 's/-mcpu=power[[:alnum:]]\+/-mcpu=power6/g'  \
>                 -e 's/^/ -fno-strict-aliasing /' )"             \
>         TARGET_LDFLAGS=-static                                  \
>          --with-platform=%{platform}                            \

I confirm that this patch solves the ppc64le boot issue.
 
> a scratch build with this fix applied is at
> http://koji.fedoraproject.org/koji/taskinfo?taskID=16697884
> Please test before we will commit the fix and do a proper build.

Updated grub2 sub-packages in ppc64le box with sub-packages available in this scratch build. Ran grub2-install command after update and rebooted system. It works fine.

Comment 3 Fedora Update System 2016-12-08 15:56:53 UTC
grub2-2.02-0.38.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-a098b75b13

Comment 4 Fedora Update System 2016-12-08 15:57:02 UTC
grub2-2.02-0.38.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-a098b75b13

Comment 5 Fedora Update System 2016-12-08 15:59:40 UTC
grub2-2.02-0.38.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-9f161da889

Comment 6 Fedora Update System 2016-12-08 19:23:21 UTC
grub2-2.02-0.38.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-a098b75b13

Comment 7 Fedora Update System 2016-12-08 19:27:09 UTC
grub2-2.02-0.38.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-9f161da889

Comment 8 Sinny Kumari 2016-12-09 12:46:41 UTC
Latest rawhide, ppc64le nightly compose Fedora-Rawhide-20161209.n.0 (https://kojipkgs.fedoraproject.org/compose/rawhide/Fedora-Rawhide-20161209.n.0/compose/Server/ppc64le/iso/ ) contains grub2-2.02-0.38.fc26 . ISO boots and installs perfectly. Reboot after installation also works perfectly.

Comment 9 Fedora Update System 2016-12-09 22:30:14 UTC
grub2-2.02-0.38.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 10 Fedora Update System 2016-12-11 21:54:34 UTC
grub2-2.02-0.38.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.